{% extends "base.html.twig" %}
{% block topbar %}
    {{parent()}}
    {% include 'topbar/choix_topbar2.html.twig' %}
    {% include topbar_3 %}
{% endblock %}
{% block body %}
    <h3 style="border-bottom: 1px solid lightgray; padding-left: 5px">Editions</h3>
    <div class="col-md-12">
        <table class="table table-striped">
            <thead>
                <tr>
                    <th>Nom fichier</th><th>Date édition</th><th>Edité par</th><th>Diffusion</th><th  style="text-align: center">Statut</th><th  style="text-align: center">Apercu</th>{% if context.edit %}<th style="min-width: 100px; max-width: 100px"></th>{% endif%}
                </tr>
            </thead>
            <tbody>
                {% for edition in editions %}
                    {% if edition.etat != -1 %}
                        <tr id='{{ edition.id }}' class='edition_row {% if edition.etat == 0 %} edition_wait {% endif %}'><input type='hidden' id='doc_{{ edition.id }}' value="{{edition.document.id}}">
                    <td>{% if edition.document.nom_public is not null %}{{ edition.document.nom_public }}{% else %}{{edition.nom_tmp}}{% endif %}</td><td>{{edition.date|date('d/m/Y') }}</td><td>{{edition.auteur}}</td><td class="edition_diff">{{ edition.diffusion}}</td><td class='edition_etat' style="text-align: center">
                        {% if edition.etat == 0 %}
                            <img alt='generation du document en cours' height="20" src='{{assetsdir}}/images/ajax-loading.gif'>
                        {% endif %}
                        {% if edition.etat == 1 %}
                            <span style='color: red'>[Attente validation]</span>
                        {% endif %}
                        {% if edition.etat == 2 %}
                            <span style='color: green'>[Validé]</span>
                        {% endif %}
                        {% if edition.etat == 3 %}
                            <span style='color: green'>[Diffusé]</span>
                        {% endif %}
                    </td><td class='edition_preview' style="text-align: center">
                        {% if edition.etat == 2 or edition.etat == 3 or edition.etat == 1 %}
                            <span class='glyphicon glyphicon-eye-open edition_preview_onclick' aria-hidden='true' style="cursor: pointer"></span>
                        {% else %}
                            <span class='glyphicon glyphicon-eye-close' aria-hidden='true'></span>
                        {% endif %}
                    </td>
                    {% if context.edit %}
                        {% if edition.etat != 3 %}
                            <td class='td_valider' style="text-align: right; max-width: 100px">
                                {% if edition.etat == 1 %}
                                <button class='btn btn-gaia btn-valider'>Valider</button>
                                {% endif %}
                                {% if edition.etat != 3 %}
                                <button class='btn btn-gaia btn-annuler'>Annuler</button>
                                {% endif %}
                            </td>
                        {% endif %}
                    {% endif %}
                    </tr>
                {% endif %}
            {% endfor %}
            </tbody>
        </table>
    </div>
    <script>
        $(document).ready(function () {

            var loading = "<img alt='generation du document en cours' height='20' src='{{ajax_url}}/assets/images/ajax-loading.gif'>";
            var wait_val = "<span style='color: red'>[Attente validation]</span>";
            var statut_ok = "<span style='color: green'>[Validé]</span>";
            var statut_diffuse = "<span style='color: green'>[Diffusé]</span>";
            var valider = "<button class='btn btn-gaia btn-valider'>Valider</button> <button class='btn btn-gaia btn-annuler'>Annuler</button>";
            var diffuser = "";
            var toTrack = [];
            $('.edition_wait').toArray().forEach(function (edition) {
                toTrack.push($(edition).prop('id'));
            });

            var td_preview = function (id) {
                return "<span class='glyphicon glyphicon-eye-open edition_preview_onclick' aria-hidden='true'></span>";
            };

            var td_nopreview = "<span alt='Apercu non disponible' class='glyphicon glyphicon-eye-close' aria-hidden='true'></span>";

            function untrack(id) {
                var index = toTrack.indexOf(id);
                toTrack.splice(index, 1);
            }

            function updateStatut() {
                console.log(toTrack);
                toTrack.forEach(function (id) {
                    getStatut(id);
                });
            }

            function getStatut(id) {
                $.ajax('{{ajax_url}}/edition/getStatut/' + id).done(function (data) {
                    switch (data) {
                        case '-1':
                            $('#' + id).hide();
                            untrack(id);
                            break;
                        case '0':
                            $('#' + id).children('.edition_etat').empty().append(loading);
                            $('#' + id).children('.edition_preview').empty().append(td_nopreview);
                            $('#' + id).children('.td_valider').empty();
                            window.setTimeout(updateStatut, 3000);
                            break;
                        case '1':
                            $('#' + id).children('.edition_etat').empty().append(wait_val);
                            $('#' + id).children('.edition_preview').empty().append(td_preview);
                            $('#' + id).children('.td_valider').empty().append(valider);
                            untrack(id);
                            break;
                        case '2':
                            $('#' + id).children('.edition_etat').empty().append(statut_ok);
                            $('#' + id).children('.edition_preview').empty().append(td_preview);
                            $('#' + id).children('.td_valider').empty().append(diffuser);
                            untrack(id);
                            break;
                        case '3':
                            $('#' + id).children('.edition_etat').empty().append(statut_diffuse);
                            $('#' + id).children('.edition_preview').empty().append(td_preview);
                            $('#' + id).children('.td_valider').empty();
                            untrack(id);
                            break;

                    }
                });
            }

            $(document).on("click", '.edition_preview_onclick', function (e) {
                var id = $($(this).parents('tr')).prop('id');
                //$('#' + id).children('.edition_etat').empty().append(loading);
                window.open("{{ajax_url}}/documents/preview/" + id + "/true", 'Apercu', "width=900, height=800");
            });

            $(document).on("click", '.btn-valider', function (e) {
                var id = $($(this).parents('tr')).prop('id');
                $('#' + id).children('.edition_etat').empty().append(loading);
                $.ajax("{{ajax_url}}/edition/validate/" + id);
                toTrack.push(id);
                window.setTimeout(updateStatut, 1000);
            });

            $(document).on("click", '.btn-annuler', function (e) {
                var id = $($(this).parents('tr')).prop('id');
                // $('#' + id).children('.edition_etat').empty().append(loading);
                $.ajax("{{ajax_url}}/edition/annuler/" + id);
                $(this).parents('tr').hide();
            });

            $(document).on("click", '.btn-diffuser', function (e) {
                var id = $($(this).parents('tr')).prop('id');
                $('#' + id).children('.edition_etat').empty().append(loading);
                $.ajax("{{ajax_url}}/edition/diffuser/" + id);
            });

            updateStatut();
        });
    </script>
{% endblock %}
